IF(WIN32)
	SET(LMMS_BUILD_WIN32 1)
ELSE(WIN32)
	IF(APPLE)
		SET(LMMS_BUILD_APPLE 1)
	ELSE(APPLE)
		SET(LMMS_BUILD_LINUX 1)
	ENDIF(APPLE)
ENDIF(WIN32)

MESSAGE("PROCESSOR: ${CMAKE_SYSTEM_PROCESSOR}")
EXEC_PROGRAM( uname ARGS "-m" OUTPUT_VARIABLE Machine )
MESSAGE("Machine: ${Machine}")
SET(LMMS_HOST_X86 FALSE)
SET(LMMS_HOST_X86_64 FALSE)

IF(${Machine} MATCHES "i686" OR ${Machine} MATCHES "i386" )
	MESSAGE("-- This is an 32 bit machine")
	SET(LMMS_HOST_X86 TRUE)
ELSE(${Machine} MATCHES "i686" OR ${Machine} MATCHES "i386" )
	IF(${Machine} MATCHES "x86_64")
		MESSAGE("-- This is an 64 bit machine")
		SET(LMMS_HOST_X86_64 TRUE)
	ELSE(${Machine} MATCHES "x86_64")
		MESSAGE("Can't identify this machine. Assuming 32 bit platform ")
	ENDIF(${Machine} MATCHES "x86_64")
ENDIF(${Machine} MATCHES "i686" OR ${Machine} MATCHES "i386" )

IF(LMMS_HOST_X86_64)
	SET(LIB_DIR lib64)
ELSE(LMMS_HOST_X86_64)
	SET(LIB_DIR lib)
ENDIF(LMMS_HOST_X86_64)

IF(LMMS_BUILD_WIN32)
	SET(PLUGIN_DIR plugins)
	SET(DATA_DIR data)
	SET(LMMS_DATA_DIR data)
ELSE(LMMS_BUILD_WIN32)
	SET(PLUGIN_DIR ${LIB_DIR}/lmms)
	SET(DATA_DIR share)
	SET(LMMS_DATA_DIR ${DATA_DIR}/lmms)
ENDIF(LMMS_BUILD_WIN32)


